package solatium.blockchain;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Getter;

@Getter
public final class HashedBlock {

    private final String hash;
    private final Block block;

    @JsonCreator
    public HashedBlock(@JsonProperty("block") Block block, @JsonProperty("hash") String hash) {
        this.hash = hash;
        this.block = block;
    }

    public String getHash() {
        return hash;
    }

    public Block getBlock() {
        return block;
    }

    @Override
    public String toString() {
        return "HashedBlock{" +
                "hash='" + hash + '\'' +
                ", block=" + block +
                '}';
    }

    @Override
    public boolean equals(Object obj) {
        // if (this == obj) {
        //     return true;
        // }
        if (!(obj instanceof HashedBlock)) {
            return false;
        }
        // if (!(((HashedBlock) obj).getBlock().equals(getBlock()))) {
        //     return false;
        // }
        // if (!(((HashedBlock) obj).getHash().equals(getHash()))) {
        //     return false;
        // }
        return true;
    }
}
